<template>
    <div>
        <div
            class="uk-inline"
            v-bind:style="{ width: size + 'px', height: size + 'px' }"
        >
            <div :id="boardName" class="board-probleme" />
            <Resultat
                :afficher="exoValide || enErreur"
                :avecErreur="enErreur"
                :texteHaut="texteAAfficher"
                @reinitialiserProbleme="reinitialiser"
            />
        </div>
    </div>
</template>

<script lang="ts">
// @ts-ignore
import WGo from 'wgo';
import Goban from '@/components/goban/GobanProbleme.vue';
import Component, { mixins } from 'vue-class-component';
import Resultat from '@/components/jeu/Resultat.vue';
import { Prop } from 'vue-property-decorator';
@Component({
    components: { Resultat }
})
export default class GobanTesuji extends mixins(Goban) {
    @Prop() solution: any[];

    compteurCoup = 0;
    avancement: any[] = [];

    public mounted() {
        this.avancement = this.solution;
    }

    get texteAAfficher() {
        if (this.exoValide) {
            return 'Réussi ! ';
        }
        return 'Erreur !';
    }

    public getListener() {
        return (x, y) => {
            if (this.game.isValid(x, y)) {
                this.coupStandard(x, y);
                if (!this.exoValide) {
                    if (this.isSolution(x, y)) {
                        this.mettreAJourPossibilitesRestantes(x, y);
                        if (this.isDernierCoupAJoue()) {
                            this.afficherResultatPositif();
                        } else {
                            setTimeout(() => this.jouerCoupAdversaire(), 500);
                        }
                    } else {
                        this.enErreur = true;
                        this.$emit('envoyerResultat', false);
                    }
                }
            }
        };
    }

    private isDernierCoupAJoue(): boolean {
        return (
            this.avancement.length == 1 &&
            this.avancement[0].coups.length == this.compteurCoup + 1
        );
    }

    private afficherResultatPositif() {
        const resultat = this.avancement[0].resultat;
        this.$emit(
            'afficherCommentaire',
            this.avancement[0].coups[this.compteurCoup].commentaire
        );
        this.exoValide = resultat;
        this.enErreur = !resultat;

        this.$emit('envoyerResultat', resultat);
    }

    private isSolution(x, y) {
        return this.avancement.some(element =>
            this.isInAvancement(element, x, y)
        );
    }

    private mettreAJourPossibilitesRestantes(x, y) {
        this.avancement = this.avancement.filter(element =>
            this.isInAvancement(element, x, y)
        );
    }

    private isInAvancement(possibilite, x, y) {
        const coupSolution = possibilite.coups[this.compteurCoup];
        return coupSolution.abscisse == x && coupSolution.ordonnee == y;
    }

    private jouerCoupAdversaire() {
        this.compteurCoup++;
        const indexVariation = Math.floor(
            Math.random() * this.avancement.length
        );
        const variation = this.avancement[indexVariation];
        const coup = variation.coups[this.compteurCoup];
        const x = coup.abscisse;
        const y = coup.ordonnee;
        this.coupStandard(x, y);
        variation.marqueurs
            .filter(element => element.position == this.compteurCoup)
            .forEach(element => {
                this.afficherMarqueur(element);
            });
        this.mettreAJourPossibilitesRestantes(x, y);
        if (this.isDernierCoupAJoue()) {
            this.afficherResultatPositif();
        } else {
            this.compteurCoup++;
            this.enErreur =
                this.avancement.length == 1 &&
                !this.avancement[0].coups[this.compteurCoup];
            this.$emit('afficherCommentaire', coup.commentaire);
        }
    }

    public reinitialiser() {
        this.avancement = this.solution;
        this.exoValide = false;
        this.enErreur = false;
        this.board.removeAllObjects();
        this.setGame();
        this.compteurCoup = 0;
        this.afficherSituationInitiale();
        this.afficherMarqueursInitiaux();
        this.tool = WGo.B;
        this.$emit('afficherCommentaire');
    }
}
</script>

<style>
.board-probleme {
    position: absolute;
    z-index: 0;
}
</style>
